// TTYTrans 0.1
// Copyright (C) 2006 Daniel Mewes (danielmewes@onlinehome.de)
// Feel free to distribute, modify and/or use this code in any way you want.

#include<fstream>
#include<iostream>
#include<string>

using namespace std;

ofstream serportOut;  
ifstream serportIn;
fstream file;

void getFile(string filename);
void putFile(string filename);

void printSyntax()
{
  cerr << "Call ttytrans -[pg] <source> <destination> <Serial device>\n";
  cerr << "Use -g to fetch a file from the Portfolio.\n";
  cerr << "Use -p to send a file to the Portfolio.\n";
  cerr << "<source> is the source file, <destination> the name for destination file.\n";
}

int main(int argc, char* argv[])
{
  if (argc < 5)
  {
    printSyntax();
    return 1;
  }
  cout << "TTYTrans 0.1 by Daniel Mewes" << endl;
  
  serportIn.open(argv[4]);
  serportOut.open(argv[4]);
  
  string choice = argv[1];
  if (choice == "-g")
  {
    cout << "Getting file " << argv[2] << " from the Portfolio. Saving it to " << argv[3] << ".\n";
    string filename = argv[2];
    file.open(argv[3], ios_base::out | ios_base::trunc);
    getFile(filename);
    file.close();  
  }
  else if (choice == (char*)"-p")
  {
    cout << "Sending file " << argv[2] << " to the Portfolio. Saving it to " << argv[3] << ".\n";
    string filename = argv[3];
    file.open(argv[2], ios_base::in);
    putFile(filename);
    file.close();  
  }
  else
  {
    printSyntax();
  }

  serportOut.close();
  serportIn.close();
  return 0;
}

void putFile(string filename)
{
  string fileStr;
  char ch;
  while (!file.eof())
  {
    file.get(ch);
    fileStr += ch;
  }
  fileStr = fileStr.substr(0, fileStr.length() - 1);
  
  serportOut << 'p' << (unsigned char)(filename.length());  
  serportOut << filename;
  serportOut << (unsigned char)(fileStr.length() % 0x100) << (unsigned char)(fileStr.length() / 0x100); 
  serportOut.flush();

  unsigned int pos = 0;
  while (pos < fileStr.length())
  {
    ch = 0;
    while ((unsigned char)ch != 0x20)
     serportIn.get(ch);
    cerr << "+";
    unsigned int length = 256;
    if (fileStr.length() < length) length = fileStr.length();
    serportOut << (unsigned char)(0x30);
    serportOut << fileStr.substr(pos, length);
    serportOut.flush();
    pos += length;
  }
  cerr << endl;
}

void getFile(string filename)
{
  string fileStr;
  
  serportOut << 'g' << (unsigned char)(filename.length());  
  serportOut << filename;
  serportOut.flush();

  unsigned int length = 256;
  while (length > 0)
  {
    char ch;
    serportIn.get(ch);
    length = (unsigned char)ch;
    serportIn.get(ch);
    length += 0x100 * (unsigned char)ch;
    unsigned int length2;
    for (length2 = length; length2 > 0; length2--)
    {
      serportIn.get(ch);
      fileStr += ch;
    }
    cerr << "+";
  }

  file << fileStr;
  cerr << endl;
}
